#include <bits/stdc++.h>
using namespace std;

const long long MX=7e5+10;

vector < int > ms[2*MX];
long long mas[2*MX],ch[2*MX];

map < pair < int , int > , long long > mp;

long long fget(int a,int b,int c)
{
    return mp[make_pair(a,b)]+mp[make_pair(b,c)]+mp[make_pair(a,c)];
}

void fun()
{
    mp.clear();

    int n;
    cin>>n;

    for(int i=0;i<=2*n;i++)
    {
        mas[i]=0;
        ms[i].clear();
        ch[i]=0;
    }

    for(long long i=1;i<=n;i++)
    {
        long long a,b,c;
        cin>>a>>b>>c;

        if(a>b)
        {
            swap(a,b);
        }

        mp[make_pair(a,b)]=c;
        mp[make_pair(b,a)]=c;

        ms[a].push_back(b);
        ms[b].push_back(a);

        mas[a]+=c;
        mas[b]+=c;
    }

    long long mx=0;
    for(int i=1;i<=2*n;i++)
    {
        mx=max(mx,mas[i]);
    }

    for(int i=1;i<=2*n;i++)
    {
        if(ms[i].size()==2)
        {
            mx=max(mx,fget(i,ms[i][0],ms[i][1]));
        }
    }

    cout<<mx<<"\n";
}

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    long long t;
    cin>>t;

    while(t--)
    {
        fun();
    }

    return 0;
}